PCRE(3)

NAME
PCRE - Perl-compatible regular expressions

PCRE SAMPLE PROGRAM

A simple, complete demonstration program, to get you started with using PCRE, is supplied in the file pcredemo.c in the PCRE distribution.

The program compiles the regular expression that is its first argument, and matches it against the subject string in its second argument. No PCRE options are set, and default character tables are used. If matching succeeds, the program outputs the portion of the subject that matched, together with the contents of any captured substrings.

If the -g option is given on the command line, the program then goes on to check for further matches of the same regular expression in the same subject string. The logic is a little bit tricky because of the possibility of matching an empty string. Comments in the code explain what is going on.

On a Unix system that has PCRE installed in /usr/local, you can compile the demonstration program using a command like this:

  gcc -o pcredemo pcredemo.c -I/usr/local/include \
      -L/usr/local/lib -lpcre

Then you can run simple tests like this:

  ./pcredemo 'cat|dog' 'the cat sat on the mat'
  ./pcredemo -g 'cat|dog' 'the dog sat on the cat'

Note that there is a much more comprehensive test program, called pcretest, which supports many more facilities for testing regular expressions and the PCRE library. The pcredemo program is provided as a simple coding example.

On some operating systems (e.g. Solaris) you may get an error like this when you try to run pcredemo:

  ld.so.1: a.out: fatal: libpcre.so.0: open failed: No such file or directory

This is caused by the way shared library support works on those systems. You need to add

  -R/usr/local/lib

to the compile command to get round this problem.

Last updated: 28 January 2003
Copyright (c) 1997-2003 University of Cambridge.